﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.EventSystems;

public class WallCreate : MonoBehaviour
{
    public float WallHeight = 1f;
    public float WallThickness = 0.05f;
    public int Rounding = 1;
    public bool move = false;
    public bool BoxColliderEnabled = true;
    public enum Mode { Wall, Room, Pole};
    public static Mode mode = Mode.Wall;
    GameObject wall;
    public static List<GameObject> Walls = new List<GameObject>();
    public static List<Wall> Rooms = new List<Wall>();

    private Vector3 screenPoint;
    private Vector3 offset;
    private Vector3 curScreenPoint;
    private Vector3 curPosition;

    private Vector3 start_pos;
    Vector3 Point;


    // Start is called before the first frame update
    void Start()
    {
       // gameObject.GetComponent<BoxCollider>().enabled = BoxColliderEnabled;
        //cursor_end = transform.GetChild(6).gameObject; 
        Point = Camera.main.WorldToScreenPoint(gameObject.transform.position);
    }
   
    // Update is called once per frame
    void Update()
    {
        // if (gameObject.GetComponent<BoxCollider>().enabled != BoxColliderEnabled) gameObject.GetComponent<BoxCollider>().enabled = BoxColliderEnabled;
        if (!Input.GetMouseButtonDown(0))
        {
           
            transform.position = Camera.main.ScreenToWorldPoint(new Vector3(Input.mousePosition.x, Input.mousePosition.y, Point.z));
            Debug.Log($"transform.position={transform.position}");
        }
    }

    void OnMouseDown()
    {
        if (!EventSystem.current.IsPointerOverGameObject())
        {
            //Debug.Log(StagesEditorController.indexCursor);

            screenPoint = Camera.main.WorldToScreenPoint(gameObject.transform.position);
            //s_point = Camera.main.WorldToScreenPoint(gameObject.transform.position);
            start_pos = Camera.main.ScreenToWorldPoint(new Vector3(Input.mousePosition.x, Input.mousePosition.y, screenPoint.z));
            Debug.Log($"start_pos = {start_pos}");
            offset = gameObject.transform.position - Camera.main.ScreenToWorldPoint(new Vector3(Input.mousePosition.x, Input.mousePosition.y, screenPoint.z));

            switch (mode)
            {
                case Mode.Wall:
                    wall = AddWall(Vector3.zero);
                    break;
                case Mode.Room:
                    wall = AddRoom();
                    break;
            }
        }
    }

    float scale_x;
    float scale_z;
    void OnMouseDrag()
    {
        if (!EventSystem.current.IsPointerOverGameObject()) {
            curScreenPoint = new Vector3(Input.mousePosition.x, Input.mousePosition.y, screenPoint.z);
            // e_point = Camera.main.WorldToScreenPoint(gameObject.transform.position);
            curPosition = Camera.main.ScreenToWorldPoint(curScreenPoint) + offset;

            var end_pos = Camera.main.ScreenToWorldPoint(new Vector3(Input.mousePosition.x, Input.mousePosition.y, screenPoint.z));

            scale_x = (float)Math.Round(end_pos.x - start_pos.x, Rounding);
            scale_z = (float)Math.Round(end_pos.z - start_pos.z, Rounding);

            switch (mode)
            {
                case Mode.Wall:
                    if (scale_x > scale_z/* && x_mod >= 0.4f*/)
                    {
                        wall.transform.localScale = new Vector3(scale_x, WallHeight, WallThickness);
                        wall.transform.position = new Vector3(scale_x / 2 + start_pos.x, WallHeight / 2, start_pos.z);
                    }
                    if (scale_z > scale_x/* && z_mod >= 0.4f*/)
                    {
                   
                        wall.transform.localScale = new Vector3(WallThickness, WallHeight, scale_z);
                        wall.transform.position = new Vector3(start_pos.x, WallHeight/2, scale_z/2+start_pos.z);
                    }                    

                    break;
                case Mode.Room:
                    /*if (scale_x > 0 && scale_z > 0) */LocationController.Cube(wall, new Vector3(scale_x, scale_z, WallHeight), 
                                                            new Vector2((float)Math.Round(start_pos.x,Rounding), (float)Math.Round(start_pos.z,Rounding)), WallThickness);
                    break;
                //case Mode.Pole:
                //    AddWall(pos);
                //    break;
            }
        }
    }

    private void OnMouseUp()
    {
        var end_pos = Camera.main.ScreenToWorldPoint(new Vector3(Input.mousePosition.x, Input.mousePosition.y, screenPoint.z));
        Debug.Log($"end_pos = {end_pos}");

        if (mode == Mode.Room) Rooms.Add(new Wall { start_width = start_pos.x, start_height = start_pos.z, end_width = scale_x, end_height = scale_z });
    }

    GameObject AddWall(Vector3 pos)
    {
        var wall = Instantiate(Resources.Load("GameObjects/Pole", typeof(GameObject))) as GameObject;
        wall.transform.position = pos;
        wall.transform.SetParent(GameObject.Find("Walls").transform);
        Walls.Add(wall);
        return wall;
    }

    GameObject AddRoom()
    {
        var room = Instantiate(Resources.Load("GameObjects/Cube", typeof(GameObject))) as GameObject;
        room.transform.SetParent(GameObject.Find("Walls").transform);
        LocationController.Cube(room, new Vector3(0.1f, 0.1f, 1));
        for (var i = 0; i < room.transform.childCount; i++)
            if (room.transform.GetChild(i).gameObject.activeSelf == true)            
                Walls.Add(room.transform.GetChild(i).gameObject);
            
        return room;
    }
}
